.\"
.\" Copyright (c) 2001 Yar Tikhiy
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man4/vlan.4,v 1.1.2.6 2002/08/30 11:53:56 yar Exp $
.\" $DragonFly: src/share/man/man4/vlan.4,v 1.12 2008/03/16 17:44:24 swildner Exp $
.\"
.Dd July 25, 2001
.Dt VLAN 4
.Os
.Sh NAME
.Nm vlan
.Nd IEEE 802.1Q VLAN network interface
.Sh SYNOPSIS
.Cd pseudo-device vlan Op Ar count
.\"
.Sh DESCRIPTION
The
.Nm
driver demultiplexes frames tagged according to
the IEEE 802.1Q standard into logical
.Nm
network interfaces, which allows routing/bridging between
multiple VLANs through a single switch trunk port.
.Pp
Each
.Nm
interface is created at runtime using interface cloning.
This is
most easily done with the
.Xr ifconfig 8
.Cm create
command or using the
.Va cloned_interfaces
variable in
.Xr rc.conf 5 .
.Pp
To function, a
.Nm
interface must be assigned a parent interface and
numeric VLAN tag using
.Xr ifconfig 8 .
A single parent can be assigned to multiple
.Nm
interfaces provided they have different tags.
The parent interface is likely to be an ethernet card connected
to a properly configured switch port.
The VLAN tag should match one of those set up in the switched
network.
.Pp
The
.Nm
driver supports efficient operation over parent interfaces that can provide
help in processing VLANs.
Such interfaces are automatically recognized by their capabilities.
Depending on the level of sophistication found in a physical
interface, it may do full VLAN processing or just be able to
receive and transmit frames exceeding the maximum Ethernet frame size
by the length of a 802.1Q header.
The capabilities may be user-controlled by the respective parameters to
.Xr ifconfig 8 ,
.Cm vlanhwtag
and
.Cm vlanmtu .
However, a physical interface is not obliged to react to them:
It may have either capability enabled permanently without
a way to turn it off.
The whole issue is very specific to a particular device and its driver.
.\"
.Ss "Selecting the Right Network Interface Card to Run VLANs Through"
By now, the only NICs that have both hardware support and proper
driver hooks for the 802.1Q VLAN technology in
.Dx
are
.Xr bce 4 ,
.Xr bge 4 ,
.Xr em 4 ,
.\".Xr msk 4 ,
.Xr nfe 4 ,
.Xr nge 4 ,
.Xr re 4 ,
.Xr stge 4 ,
.Xr ti 4 ,
.Xr txp 4 ,
and
.Xr vge 4 .
.Pp
The rest of the ethernet NICs supported by
.Dx
can run
VLANs using software emulation in the
.Nm
driver.
However, most of them lack the capability
of transmitting and/or receiving oversized frames.
Using such a NIC as a parent interface
implies a reduced MTU on the corresponding
.Nm
interfaces.
In the modern Internet, this is likely to cause
.Xr tcp 4
connectivity problems due to massive, inadequate
.Xr icmp 4
filtering that breaks the Path MTU Discovery mechanism.
.Pp
The NICs that support oversized frames are as follows:
.Bl -tag -width ".Xr fxp 4 " -offset indent
.It Xr dc 4
supports long frames for
.Nm
natively.
.It Xr de 4
requires defining
.Dv BIG_PACKET
in the
.Pa /sys/dev/netif/de/if_de.c
source file and rebuilding the kernel.
The hack works only for the 21041, 21140, and 21140A chips.
.It Xr et 4
supports long frames for
.Nm
natively.
.It Xr fxp 4
supports long frames for
.Nm
natively.
.It Xr sis 4
supports long frames for
.Nm
natively.
.It Xr ste 4
supports long frames for
.Nm
natively.
.It Xr tl 4
has support for long frames.
.It Xr tx 4
supports long frames for
.Nm
natively.
.It Xr xl 4
supports long frames only if the card is built on a newer chip
(Cyclone and above).
.El
.Pp
Note:
Unless marked as having native support for
.Nm ,
the above drivers don't inform the
.Nm
driver about their long frame handling capability.
Just increase the MTU of a
.Nm
interface if it appears to be lower than 1500 bytes after
attaching to a parent known to support long frames.
.Sh SEE ALSO
.Xr ifconfig 8
.Sh BUGS
No 802.1Q features except VLAN tagging are implemented.
